/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


package com.funambol.mailclient.ui.view;

import com.funambol.mailclient.ui.controller.Theme;
import com.funambol.mailclient.ui.controller.UIController;
import com.funambol.util.Log;
import java.io.IOException;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;


public class FunAd {
    
    private Image small;
    private Image large;
    
    private Command actionCommand;
    private Command dismissCommand;
    
    private boolean enabled = false;
    
    /** Creates a new instance of FunAd */
    public FunAd() {
        String r =UIController.midlet.getAppProperty("Ads");
        if (r!=null && (r.toLowerCase().trim().equals("true")))  {
            enabled = true;
        }
    }
    /**
     * @return true if the ad is enabled (i.e. if this is an ad-enabled build)
     */
    public boolean isEnabled() {
        return enabled;
    }
    
    private Image getSmallImage() throws IOException {
        
        if (small == null) {
            
            small = Image.createImage(Theme.AD_IMG_SMALL_PATH);
            
        }
        return small;
        
        
    }
    /**
     * return the actioncommand
     */
    public Command getActionCommand() {
        
        if (actionCommand == null) {
            actionCommand =   new Command("Tell Me More", Command.OK,0);
        }
        return actionCommand;
        
        
    }
    /**
     *@return  the dismisscommand
     */
    public Command getDismissCommand() {
        if (dismissCommand == null) {
            dismissCommand = new Command("Close", Command.BACK,0);
        }
        return dismissCommand;
    }
    /**
     * paint the small add on the given graphic at 0,0 position
     */
    public int paintSmallAd(Graphics g) {
        if (enabled) {
            try {
                g.drawImage(getSmallImage(),0,0,g.TOP|g.LEFT);
                return small.getHeight();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return 0;
    }
    
    /**
     * paint the large add on the given graphic at 0,0 position
     */
    public int paintLargeAd(Graphics g) {
        if (enabled) {
            try {
                g.drawImage(getLargeImage(),0,0,g.TOP|g.LEFT);
                return large.getHeight();
            } catch (IOException ex) {
                Log.error("unamble to open image");
                ex.printStackTrace();
            }
        }
        return 0;
    }
    /**
     * perform the action
     */
    public void doAction() {
        
        UIController.openUrl("http://www.starbucks.com");
        Log.info("DoAction!!");
    }
    
    /**
     * free some memory
     */
    public void freeMemory() {
        large = null;
    }
    
    private Image getLargeImage() throws IOException {
        if (large == null) {
            large = Image.createImage(Theme.AD_IMG_LARGE_PATH);
        }
        return large;
    }
    
}
